import 'package:easy/src/easy_bloc.dart';
import 'package:flutter/material.dart';
import 'bloc_provider.dart';

class Consumer<T extends EasyBloc> extends StatefulWidget {
  final Widget data;
  final String tag;
  final bool Function(T oldValue, T newValue) distinct;

  Consumer(
      {Key key, @required this.data, this.tag = "global", this.distinct})
      : super(key: key);

  @override
  _ConsumerState<T> createState() => _ConsumerState<T>();
}

class _ConsumerState<T extends EasyBloc> extends State<Consumer<T>> {
  T data;

  String tag = "global";

  void listener() {
    T newValue = BlocProvider.tag(widget.tag).getBloc<T>();
    if (widget.distinct == null || widget.distinct(data, newValue)) {
      setState(() {
        data = newValue;
      });
    }
  }

  @override
  void initState() {
    data = BlocProvider.tag(widget.tag).getBloc<T>();
    data.addListener(listener);
    super.initState();
  }

  @override
  void dispose() {
    data.removeListener(listener);
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    return widget.data;
  }
}
